/*

Copyright (C) 2004 Jon Snell, jsnell@e-normous.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

File Description:
This file is the main program.  It interfaces with gnome to create our applet.

Todo:
More features

*/

#include <string.h>

#include <panel-applet.h>
#include <gtk/gtklabel.h>
#include "caller_id.h"
#include "modem.h"



static const char Context_menu_xml [] =
   "<popup name=\"button3\">\n"
/*   "   <menuitem name=\"Properties Item\" "
   "             verb=\"Properties\" "
   "           _label=\"_Preferences...\"\n"
   "          pixtype=\"stock\" "
   "          pixname=\"gtk-properties\"/>\n" */
   "   <menuitem name=\"About Item\" "
   "             verb=\"ExampleAbout\" "
   "           _label=\"_About...\"\n"
   "          pixtype=\"stock\" "
   "          pixname=\"gnome-stock-about\"/>\n"
   "</popup>\n";


/*
static void
display_properties_dialog (BonoboUIComponent *uic,
                                 struct MultiRes *applet) {
	/* Construct the properties dialog and show it here /
}
*/

static void
display_about_dialog (BonoboUIComponent *uic,
                                 CIDData *cid) {
	/* Construct the properties dialog and show it here */
  /* if (cid->about_dialog) {
    gtk_window_set_screen (GTK_WINDOW (cid->about_dialog),
			   gtk_widget_get_screen (cid->panel.applet));
    
    gtk_window_present (GTK_WINDOW (cid->about_dialog));
    return;
  }
  */

    static const gchar *authors[] =
    {
        "Jon Snell <jsnell@e-normous.com>",
        NULL
    };

    const gchar *documenters[] =
    {
        "(none)",
	NULL
    };

    const gchar *translator_credits = _("translator_credits");



    cid->about_dialog = (GtkWidget *)  gnome_about_new ( _("Caller ID"),
					 _(VERSION),
					 _("(C) 2004 Jon Snell (jsnell@e-normous.com)\n"),
					 _("The Caller ID Applet is a simple applet for showing you who is calling"),
					 authors,
					 documenters,
					 strcmp (translator_credits, "translator_credits") != 0 ? translator_credits : (char *) NULL,
                                         (char *)NULL); 
  gtk_window_set_wmclass (GTK_WINDOW (cid->about_dialog), "Caller ID", "Caller ID");
  gtk_window_set_screen (GTK_WINDOW (cid->about_dialog),
			 gtk_widget_get_screen (cid->panel.applet));

    g_signal_connect (G_OBJECT(cid->about_dialog), "destroy",
                      G_CALLBACK(gtk_widget_destroyed), &cid->about_dialog);
    gtk_widget_show (cid->about_dialog);
}



static const BonoboUIVerb myexample_menu_verbs [] =  {
  BONOBO_UI_VERB ("ExampleAbout",  (BonoboUIVerbFn) display_about_dialog),
  BONOBO_UI_VERB_END
};


static gboolean
myexample_applet_fill (PanelApplet *applet,
   const gchar *iid,
   gpointer data)
{
  CIDData *cid;
	
  cid = g_new0(CIDData, 1);
	if (strcmp (iid, "OAFIID:ExampleApplet") != 0)
		return FALSE;

	cid->label = gtk_label_new ("Call ID");
	cid->initialized = 0;
	cid->initialize_step = 0;
	cid->input_buf[0] = 0;
	cid->input_str[0] = 0;
	cid->line_complete = 0; 
	cid->about_dialog = NULL;
	cid->panel.applet = GTK_WIDGET (applet);

	cid->cur_cid_record = g_new0(CIDRecord, 1);
	cid->cur_cid_record->partial = 0;
	cid->cur_cid_record->complete = 0;
	cid->cur_cid_record->ring_count = 0;

	gtk_container_add (GTK_CONTAINER (applet), cid->label);

	gtk_widget_show_all (GTK_WIDGET (applet));

panel_applet_setup_menu (PANEL_APPLET (applet),
                         Context_menu_xml,
                         myexample_menu_verbs,
                         cid);

	cid->timeout = gtk_timeout_add(TIMEOUT_VALUE, cid_timeout_callback, (gpointer)cid);
	return TRUE;
}


static int 
cid_timeout_callback(gpointer data)
{
  CIDData *cid;
  cid = (CIDData *) data;
  char *m_data;
  char f_buf[500];

  
  if (!(cid->initialized))
    init_modem(cid);
  else
    {
      if (m_data = modem_gets(cid)) // all ready, so let's read
	{
	  // we don't bother with error detection right now, it's a lot more complicated
	  parse_modem_text(m_data, cid->cur_cid_record);
	  if (cid->cur_cid_record->partial && (!(cid->cur_cid_record->complete)))
	    {
	      gtk_label_set_text((GtkLabel *)cid->label, (const char *)"Getting CID"); 
	    }
	  
	  if (cid->cur_cid_record->complete)
	    {
	      sprintf(f_buf, "CID: %s %s", cid->cur_cid_record->nmbr, cid->cur_cid_record->name);
	      gtk_label_set_text((GtkLabel *)cid->label, (const char *)f_buf);
	      cid->cur_cid_record->partial = 0;
	      cid->cur_cid_record->complete = 0;
	      cid->cur_cid_record->ring_count = 0;
	    }
	}
    }
 
 

  
    return(1);
}

/*
TODO: 
on close:

kill timer,
      fcntl(fd, F_SETFL, 0);
close(fd); (modem)
*/


PANEL_APPLET_BONOBO_FACTORY ("OAFIID:ExampleApplet_Factory",
                             PANEL_TYPE_APPLET,
                             "Caller ID Applet",
                             "0",
                             myexample_applet_fill,
                             NULL);
