/*
Copyright (C) 2004 Jon Snell, jsnell@e-normous.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include <glib.h>
#include <gtk/gtk.h>
#include <panel-applet.h>

#ifndef __CALLER_ID_H__
#define __CALLER_ID_H__

#define TIMEOUT_VALUE 50
#define VERSION "0.2"


G_BEGIN_DECLS


typedef struct
{
  int partial; // 0 if the information is partially filled out
  int complete; // 1 if the information is complete
  int ring_count;
  int error; // 1 if there's an error
  char date[4];
  char time[4];
  char nmbr[32];
  char name[32];
}CIDRecord;


typedef struct
{
    int timeout;
  GtkWidget *label;
  int initialized;
  int initialize_step; 
  int modem; 

  char input_buf[1024]; // should be gchar??
  char input_str[1024];
  int line_complete; 

  CIDRecord *cur_cid_record;

  GtkWidget *about_dialog;
    struct
    {
        GtkWidget *applet;
        GtkWidget *frame;
    } panel;

  /*   
    GtkWidget *prefs_dialog;
  */
}CIDData;


static int 
cid_timeout_callback(gpointer data);

G_END_DECLS

#endif
